Index: src/include/nodes/parsenodes.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/nodes/parsenodes.h,v
retrieving revision 1.179
diff -c -r1.179 parsenodes.h
*** src/include/nodes/parsenodes.h	2002/05/22 17:21:01	1.179
--- src/include/nodes/parsenodes.h	2002/06/15 16:39:45
***************
*** 123,128 ****
--- 123,129 ----
  	bool		pct_type;		/* %TYPE specified? */
  	int32		typmod;			/* type modifier */
  	List	   *arrayBounds;	/* array bounds */
+ 	RangeVar   *serial;			/* Serial sequence reference*/
  } TypeName;
  
  /*
***************
*** 947,953 ****
  	RangeVar   *pktable;		/* Primary key table */
  	List	   *fk_attrs;		/* Attributes of foreign key */
  	List	   *pk_attrs;		/* Corresponding attrs in PK table */
! 	char	   *match_type;		/* FULL or PARTIAL */
  	int32		actions;		/* ON DELETE/UPDATE actions */
  	bool		deferrable;		/* DEFERRABLE */
  	bool		initdeferred;	/* INITIALLY DEFERRED */
--- 948,954 ----
  	RangeVar   *pktable;		/* Primary key table */
  	List	   *fk_attrs;		/* Attributes of foreign key */
  	List	   *pk_attrs;		/* Corresponding attrs in PK table */
! 	char		match_type;		/* FULL, PARTIAL, or UNSPECIFIED */
  	int32		actions;		/* ON DELETE/UPDATE actions */
  	bool		deferrable;		/* DEFERRABLE */
  	bool		initdeferred;	/* INITIALLY DEFERRED */
***************
*** 999,1004 ****
--- 1000,1006 ----
  {
  	NodeTag		type;
  	char	   *plname;			/* PL name */
+ 	int			behavior;
  } DropPLangStmt;
  
  /* ----------------------
***************
*** 1131,1136 ****
--- 1133,1139 ----
  	RangeVar   *relation;		/* owning relation */
  	char	   *property;		/* name of rule, trigger, etc */
  	int			removeType;
+ 	int			behavior;
  } DropPropertyStmt;
  
  /* ----------------------
***************
*** 1221,1226 ****
--- 1224,1230 ----
  	NodeTag		type;
  	List	   *aggname;		/* aggregate to drop */
  	TypeName   *aggtype;		/* TypeName for input datatype, or NULL */
+ 	int			behavior;
  } RemoveAggrStmt;
  
  /* ----------------------
***************
*** 1232,1237 ****
--- 1236,1242 ----
  	NodeTag		type;
  	List	   *funcname;		/* function to drop */
  	List	   *args;			/* types of the arguments */
+ 	int			behavior;
  } RemoveFuncStmt;
  
  /* ----------------------
***************
*** 1243,1248 ****
--- 1248,1254 ----
  	NodeTag		type;
  	List	   *opname;			/* operator to drop */
  	List	   *args;			/* types of the arguments */
+ 	int			behavior;
  } RemoveOperStmt;
  
  /* ----------------------
Index: src/include/rewrite/rewriteRemove.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/rewrite/rewriteRemove.h,v
retrieving revision 1.13
diff -c -r1.13 rewriteRemove.h
*** src/include/rewrite/rewriteRemove.h	2002/04/18 20:01:11	1.13
--- src/include/rewrite/rewriteRemove.h	2002/06/15 16:39:45
***************
*** 14,20 ****
  #ifndef REWRITEREMOVE_H
  #define REWRITEREMOVE_H
  
! extern void RemoveRewriteRule(Oid owningRel, const char *ruleName);
! extern void RelationRemoveRules(Oid relid);
  
  #endif   /* REWRITEREMOVE_H */
--- 14,20 ----
  #ifndef REWRITEREMOVE_H
  #define REWRITEREMOVE_H
  
! extern void RemoveRewriteRule(Oid owningRel, const char *ruleName, int behavior);
! extern void RemoveRewriteRuleById(Oid ruleId, int behavior);
  
  #endif   /* REWRITEREMOVE_H */
Index: src/include/utils/builtins.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/utils/builtins.h,v
retrieving revision 1.184
diff -c -r1.184 builtins.h
*** src/include/utils/builtins.h	2002/06/13 03:40:49	1.184
--- src/include/utils/builtins.h	2002/06/15 16:39:47
***************
*** 344,349 ****
--- 344,350 ----
  extern Datum regtypeout(PG_FUNCTION_ARGS);
  
  /* ruleutils.c */
+ extern Datum pg_get_fkeydef(PG_FUNCTION_ARGS);
  extern Datum pg_get_ruledef(PG_FUNCTION_ARGS);
  extern Datum pg_get_viewdef(PG_FUNCTION_ARGS);
  extern Datum pg_get_viewdef_name(PG_FUNCTION_ARGS);
Index: src/test/regress/parallel_schedule
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/parallel_schedule,v
retrieving revision 1.9
diff -c -r1.9 parallel_schedule
*** src/test/regress/parallel_schedule	2002/04/05 11:56:55	1.9
--- src/test/regress/parallel_schedule	2002/06/15 16:39:50
***************
*** 75,77 ****
--- 75,79 ----
  # ----------
  # "plpgsql" cannot run concurrently with "rules"
  test: limit plpgsql temp domain
+ 
+ test: drop
Index: src/test/regress/serial_schedule
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/serial_schedule,v
retrieving revision 1.9
diff -c -r1.9 serial_schedule
*** src/test/regress/serial_schedule	2002/04/05 11:56:55	1.9
--- src/test/regress/serial_schedule	2002/06/15 16:39:50
***************
*** 82,85 ****
--- 82,86 ----
  test: plpgsql
  test: temp
  test: domain
+ test: drop
  
Index: src/test/regress/sql/alter_table.sql
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/sql/alter_table.sql,v
retrieving revision 1.28
diff -c -r1.28 alter_table.sql
*** src/test/regress/sql/alter_table.sql	2002/05/03 00:32:19	1.28
--- src/test/regress/sql/alter_table.sql	2002/06/15 16:39:54
***************
*** 218,228 ****
  -- Try (and succeed)
  ALTER TABLE tmp3 add constraint tmpconstr foreign key (a) references tmp2 match full;
  
  -- Try (and fail) to create constraint from tmp5(a) to tmp4(a) - unique constraint on
  -- tmp4 is a,b
- 
  ALTER TABLE tmp5 add constraint tmpconstr foreign key(a) references tmp4(a) match full;
  
  DROP TABLE tmp5;
  
  DROP TABLE tmp4;
--- 218,235 ----
  -- Try (and succeed)
  ALTER TABLE tmp3 add constraint tmpconstr foreign key (a) references tmp2 match full;
  
+ -- Fail to add check constraint of same name as foreign key constraint
+ ALTER TABLE tmp3 add constraint tmpconstr check(a is not null);
+ 
  -- Try (and fail) to create constraint from tmp5(a) to tmp4(a) - unique constraint on
  -- tmp4 is a,b
  ALTER TABLE tmp5 add constraint tmpconstr foreign key(a) references tmp4(a) match full;
  
+ -- Drop a few constraints
+ ALTER TABLE tmp5 DROP CONSTRAINT tmpconstr RESTRICT;
+ ALTER TABLE tmp3 DROP CONSTRAINT tmpconstr CASCADE;
+ -- Attempt to add the previously failing row now that constraint is gone
+ INSERT INTO tmp3 values (5,50);
  DROP TABLE tmp5;
  
  DROP TABLE tmp4;
***************
*** 250,256 ****
  ALTER TABLE FKTABLE ADD FOREIGN KEY(ftest1) references pktable;
  -- As should this
  ALTER TABLE FKTABLE ADD FOREIGN KEY(ftest1) references pktable(ptest1);
! DROP TABLE pktable;
  DROP TABLE fktable;
  
  CREATE TEMP TABLE PKTABLE (ptest1 int, ptest2 inet,
--- 257,264 ----
  ALTER TABLE FKTABLE ADD FOREIGN KEY(ftest1) references pktable;
  -- As should this
  ALTER TABLE FKTABLE ADD FOREIGN KEY(ftest1) references pktable(ptest1);
! DROP TABLE pktable restrict;
! DROP TABLE pktable cascade;
  DROP TABLE fktable;
  
  CREATE TEMP TABLE PKTABLE (ptest1 int, ptest2 inet,
***************
*** 283,288 ****
--- 291,301 ----
  insert into atacc1 (test) values (2);
  -- should succeed
  insert into atacc1 (test) values (4);
+ -- should fail
+ alter table atacc1 DROP constraint unknown_constraint;
+ -- should succeed
+ alter table atacc1 drop constraint atacc_test1;
+ insert into atacc1 (test) values (2);
  drop table atacc1;
  
  -- let's do one where the check fails when added
***************
*** 361,366 ****
--- 374,382 ----
  insert into atacc1 (test) values (4);
  -- try adding a unique oid constraint
  alter table atacc1 add constraint atacc_oid1 unique(oid);
+ -- Remove the constraint and ensure we pass the failed test
+ alter table atacc1 drop constraint atacc_test1;
+ insert into atacc1 (test) values (2);
  drop table atacc1;
  
  -- let's do one where the unique constraint fails when added
Index: src/test/regress/sql/create_misc.sql
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/sql/create_misc.sql,v
retrieving revision 1.9
diff -c -r1.9 create_misc.sql
*** src/test/regress/sql/create_misc.sql	2001/05/21 16:54:46	1.9
--- src/test/regress/sql/create_misc.sql	2002/06/15 16:39:54
***************
*** 217,219 ****
--- 217,226 ----
  INSERT INTO serialTest VALUES ('wrong', NULL);
  
  SELECT * FROM serialTest;
+ 
+ DROP TABLE serialTest;
+ 
+ -- Ensure that Serial sequences are dropped with the table
+ CREATE TABLE serialTest (f1 text, f2 serial);
+ 
+ DROP TABLE serialTest;
Index: src/test/regress/sql/create_view.sql
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/sql/create_view.sql,v
retrieving revision 1.3
diff -c -r1.3 create_view.sql
*** src/test/regress/sql/create_view.sql	2000/06/10 05:19:26	1.3
--- src/test/regress/sql/create_view.sql	2002/06/15 16:39:54
***************
*** 17,21 ****
  
  CREATE VIEW toyemp AS
     SELECT name, age, location, 12*salary AS annualsal
!    FROM emp;
! 
--- 17,20 ----
  
  CREATE VIEW toyemp AS
     SELECT name, age, location, 12*salary AS annualsal
!    FROM emp;
\ No newline at end of file
Index: src/test/regress/sql/domain.sql
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/sql/domain.sql,v
retrieving revision 1.2
diff -c -r1.2 domain.sql
*** src/test/regress/sql/domain.sql	2002/03/20 19:45:13	1.2
--- src/test/regress/sql/domain.sql	2002/06/15 16:39:54
***************
*** 6,12 ****
  
  create domain basetypetest domaindroptest;
  
- drop domain domaindroptest cascade;
  drop domain domaindroptest;
  
  
--- 6,11 ----
***************
*** 108,118 ****
  insert into defaulttest default values;
  insert into defaulttest default values;
  select * from defaulttest;
- 
- drop sequence ddef4_seq;
- drop table defaulttest;
- drop domain ddef1 restrict;
- drop domain ddef2 restrict;
- drop domain ddef3 restrict;
- drop domain ddef4 restrict;
- drop domain ddef5 restrict;
--- 107,109 ----
Index: src/test/regress/sql/drop.sql
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/sql/drop.sql,v
retrieving revision 1.5
diff -c -r1.5 drop.sql
*** src/test/regress/sql/drop.sql	2001/10/03 20:54:22	1.5
--- src/test/regress/sql/drop.sql	2002/06/15 16:39:54
***************
*** 1,247 ****
  --
! -- drop.source
  --
  
! --
! -- this will fail if the user is not the postgres superuser.
! -- if it does, don't worry about it (you can turn usersuper
! -- back on as "postgres").  too many people don't follow 
! -- directions and run this as "postgres", though...
! --
! UPDATE pg_user
!    SET usesuper = 't'::bool
!    WHERE usename = 'postgres';
! 
! 
! --
! -- FUNCTION REMOVAL
! --
! DROP FUNCTION hobbies(person);
! 
! DROP FUNCTION hobby_construct(text,text);
! 
! DROP FUNCTION equipment(hobbies_r);
! 
! DROP FUNCTION user_relns();
! 
! DROP FUNCTION widget_in(opaque);
! 
! DROP FUNCTION widget_out(opaque);
! 
! DROP FUNCTION pt_in_widget(point,widget);
! 
! DROP FUNCTION overpaid(emp);
! 
! DROP FUNCTION boxarea(box);
! 
! DROP FUNCTION interpt_pp(path,path);
! 
! DROP FUNCTION reverse_name(name);
! 
! DROP FUNCTION oldstyle_length(int4, text);
! 
! --
! -- OPERATOR REMOVAL
! --
! DROP OPERATOR ## (path, path);
! 
! DROP OPERATOR <% (point, widget);
! 
! -- left unary 
! DROP OPERATOR @#@ (none, int4);
! 
! -- right unary 
! DROP OPERATOR #@# (int4, none);	
! 
! -- right unary 
! DROP OPERATOR #%# (int4, none);	
! 
! 
! --
! -- ABSTRACT DATA TYPE REMOVAL
! --
! DROP TYPE city_budget;
! 
! DROP TYPE widget;
! 
! 
! --
! -- RULE REMOVAL
! --	(is also tested in queries.source)
! --
! 
! --
! -- AGGREGATE REMOVAL
! --
! DROP AGGREGATE newavg (int4);
! 
! DROP AGGREGATE newsum (int4);
! 
! DROP AGGREGATE newcnt (int4);
! 
! 
! --
! -- CLASS REMOVAL
! --	(inheritance hierarchies are deleted in reverse order)
! --
! 
! --
! -- DROP ancillary data structures (i.e. indices)
! --
! DROP INDEX onek_unique1;
! 
! DROP INDEX onek_unique2;
! 
! DROP INDEX onek_hundred;
! 
! DROP INDEX onek_stringu1;
! 
! DROP INDEX tenk1_unique1;
! 
! DROP INDEX tenk1_unique2;
! 
! DROP INDEX tenk1_hundred;
! 
! DROP INDEX tenk2_unique1;
! 
! DROP INDEX tenk2_unique2;
! 
! DROP INDEX tenk2_hundred;
! 
! -- DROP INDEX onek2_u1_prtl;
! 
! -- DROP INDEX onek2_u2_prtl;
  
- -- DROP INDEX onek2_stu1_prtl;
  
! DROP INDEX rect2ind;
  
- DROP INDEX rix;
  
! DROP INDEX iix;
  
- DROP INDEX six;
  
! DROP INDEX hash_i4_index;
  
- DROP INDEX hash_name_index;
  
! DROP INDEX hash_txt_index;
  
- DROP INDEX hash_f8_index;
  
! -- DROP INDEX hash_ovfl_index;
  
- DROP INDEX bt_i4_index;
  
- DROP INDEX bt_name_index;
  
- DROP INDEX bt_txt_index;
- 
- DROP INDEX bt_f8_index;
- 
- 
- DROP TABLE  onek;
- 
- DROP TABLE  onek2;
- 
- DROP TABLE  tenk1;
- 
- DROP TABLE  tenk2;
- 
- DROP TABLE  Bprime;
- 
- 
- DROP TABLE  hobbies_r;
- 
- DROP TABLE  equipment_r;
- 
- 
- DROP TABLE  aggtest;
- 
- DROP TABLE  xacttest;
- 
- DROP TABLE  arrtest;
- 
- DROP TABLE  iportaltest;
- 
- 
- DROP TABLE  f_star;
- 
- DROP TABLE  e_star;
- 
- DROP TABLE  d_star;
- 
- DROP TABLE  c_star;
- 
- DROP TABLE  b_star;
- 
- DROP TABLE  a_star;
- 
- 
- --
- -- must be in reverse inheritance order
- --
- DROP TABLE  stud_emp;
- 
- DROP TABLE  student;
- 
- DROP TABLE  slow_emp4000;
- 
- DROP TABLE  fast_emp4000;
- 
- DROP TABLE  emp;
- 
- DROP TABLE  person;
- 
- 
- DROP TABLE  ramp;
- 
- DROP TABLE  real_city;
- 
- DROP TABLE  dept;
- 
- DROP TABLE  ihighway;
- 
- DROP TABLE  shighway;
- 
- DROP TABLE  road;
- 
- DROP TABLE  city;
- 
- 
- DROP TABLE  hash_i4_heap;
- 
- DROP TABLE  hash_name_heap;
- 
- DROP TABLE  hash_txt_heap;
- 
- DROP TABLE  hash_f8_heap;
- 
- -- DROP TABLE  hash_ovfl_heap;
- 
- DROP TABLE  bt_i4_heap;
- 
- DROP TABLE  bt_name_heap;
- 
- DROP TABLE  bt_txt_heap;
- 
- DROP TABLE  bt_f8_heap;
- 
- 
- DROP TABLE  ABSTIME_TBL;
- 
- DROP TABLE  RELTIME_TBL;
- 
- DROP TABLE  TINTERVAL_TBL;
- 
- --
- -- VIRTUAL CLASS REMOVAL
- --	(also tests removal of rewrite rules)
- --
- DROP VIEW street;
  
- DROP VIEW iexit;
  
- DROP VIEW toyemp;
  
--- 1,43 ----
  --
! -- Test RESTRICT and CASCADE keywords.
  --
  
! -- Ensure system types cannot be removed
! DROP TYPE int4 CASCADE;
! DROP FUNCTION nextval(text) CASCADE;
! DROP TABLE pg_type CASCADE;
  
  
! -- Function RESTRICT / CASCADE
! DROP FUNCTION widget_in(opaque) RESTRICT; -- fail
! DROP TYPE widget RESTRICT; -- fail
! DROP FUNCTION widget_in(opaque) CASCADE;
! DROP TYPE widget RESTRICT; -- doesn't exist
  
  
! -- Type RESTRICT / CASCADE
! DROP TYPE city_budget RESTRICT; -- fail
! DROP TYPE city_budget CASCADE;
! DROP TABLE city RESTRICT; -- doesn't exist
  
  
! -- Domain RESTRICT / CASCADE
! DROP DOMAIN ddef1 RESTRICT; -- fail
! DROP DOMAIN ddef1 CASCADE;
! DROP TABLE defaulttest RESTRICT; -- doesn't exist
  
  
! -- Procedural languge RESTRICT / CASCADE
! DROP LANGUAGE plpgsql RESTRICT; -- fail
! DROP LANGUAGE plpgsql CASCADE;
! SELECT recursion_test(2,3);  -- doesn't exist
  
  
! -- Foreign Key RESTRICT / CASCADE
! -- See alter table pktable and fktable tests
  
  
  
  
  
  
Index: src/test/regress/sql/foreign_key.sql
===================================================================
RCS file: /projects/cvsroot/pgsql/src/test/regress/sql/foreign_key.sql,v
retrieving revision 1.6
diff -c -r1.6 foreign_key.sql
*** src/test/regress/sql/foreign_key.sql	2002/05/03 00:32:19	1.6
--- src/test/regress/sql/foreign_key.sql	2002/06/15 16:39:57
***************
*** 40,47 ****
  -- Check FKTABLE for update of matched row
  SELECT * FROM FKTABLE;
  
! DROP TABLE PKTABLE;
! DROP TABLE FKTABLE;
  
  --
  -- check set NULL and table constraint on multiple columns
--- 40,46 ----
  -- Check FKTABLE for update of matched row
  SELECT * FROM FKTABLE;
  
! DROP TABLE PKTABLE CASCADE;
  
  --
  -- check set NULL and table constraint on multiple columns
***************
*** 92,99 ****
  -- Check FKTABLE for update of matched row
  SELECT * FROM FKTABLE;
  
! DROP TABLE PKTABLE;
! DROP TABLE FKTABLE;
  
  --
  -- check set default and table constraint on multiple columns
--- 91,97 ----
  -- Check FKTABLE for update of matched row
  SELECT * FROM FKTABLE;
  
! DROP TABLE PKTABLE CASCADE;
  
  --
  -- check set default and table constraint on multiple columns
***************
*** 147,154 ****
  -- Check FKTABLE for update of matched row
  SELECT * FROM FKTABLE;
  
! DROP TABLE PKTABLE;
! DROP TABLE FKTABLE;
  
  
  --
--- 145,151 ----
  -- Check FKTABLE for update of matched row
  SELECT * FROM FKTABLE;
  
! DROP TABLE PKTABLE CASCADE;
  
  
  --
***************
*** 197,204 ****
  -- Check PKTABLE for updates
  SELECT * FROM PKTABLE;
  
! DROP TABLE PKTABLE;
! DROP TABLE FKTABLE;
  
  
  -- MATCH unspecified
--- 194,200 ----
  -- Check PKTABLE for updates
  SELECT * FROM PKTABLE;
  
! DROP TABLE PKTABLE CASCADE;
  
  
  -- MATCH unspecified
***************
*** 532,538 ****
  delete from pktable where base1>3;
  -- cleanup
  drop table fktable;
! drop table pktable;
  drop table pktable_base;
  
  -- Now we'll do one all in 1 table with 2 columns of matching types
--- 528,534 ----
  delete from pktable where base1>3;
  -- cleanup
  drop table fktable;
! drop table pktable cascade;
  drop table pktable_base;
  
  -- Now we'll do one all in 1 table with 2 columns of matching types
***************
*** 552,558 ****
  -- this sequence of two deletes will work, since after the first there will be no (2,*) references
  delete from pktable where base2=2;
  delete from pktable where base1=2;
! drop table pktable;
  drop table pktable_base;
  
  -- 2 columns (2 tables), mismatched types
--- 548,554 ----
  -- this sequence of two deletes will work, since after the first there will be no (2,*) references
  delete from pktable where base2=2;
  delete from pktable where base1=2;
! drop table pktable cascade;
  drop table pktable_base;
  
  -- 2 columns (2 tables), mismatched types
***************
*** 565,571 ****
  create table fktable(ftest1 int, ftest2 inet, foreign key(ftest2, ftest1) references pktable);
  create table fktable(ftest1 int, ftest2 inet, foreign key(ftest2, ftest1) references pktable(base1, ptest1));
  create table fktable(ftest1 int, ftest2 inet, foreign key(ftest1, ftest2) references pktable(ptest1, base1));
! drop table pktable;
  drop table pktable_base;
  
  -- 2 columns (1 table), mismatched types
--- 561,567 ----
  create table fktable(ftest1 int, ftest2 inet, foreign key(ftest2, ftest1) references pktable);
  create table fktable(ftest1 int, ftest2 inet, foreign key(ftest2, ftest1) references pktable(base1, ptest1));
  create table fktable(ftest1 int, ftest2 inet, foreign key(ftest1, ftest2) references pktable(ptest1, base1));
! drop table pktable cascade;
  drop table pktable_base;
  
  -- 2 columns (1 table), mismatched types
***************
*** 578,583 ****
                                               pktable(base1, ptest1)) inherits (pktable_base);
  create table pktable(ptest1 inet, ptest2 inet, primary key(base1, ptest1), foreign key(ptest2, base2) references
                                               pktable(base1, ptest1)) inherits (pktable_base);
- drop table pktable;
  drop table pktable_base;
  
--- 574,578 ----
